#ifndef XEP_LIBETPAN_INLINED_H
#define XEP_LIBETPAN_INLINED_H

static inline int mailmime_get_type(struct mailmime * mime)
{
  return mime->mm_type;
};

static inline int mailmime_get_length(struct mailmime * mime)
{
  return mime->mm_length;
};

static inline struct mailmime * mailmime_get_msg_mime(struct mailmime * mime)
{
  return mime->mm_data.mm_message.mm_msg_mime;
};

static inline struct mailimf_fields * mailmime_get_msg_fields(struct mailmime * mime)
{
  return mime->mm_data.mm_message.mm_fields;
};

static inline clist * mailmime_get_multipart_list(struct mailmime * mime)
{
  return mime->mm_data.mm_multipart.mm_mp_list;
};

static inline struct mailmime_fields * mailmime_get_fields(struct mailmime * mime)
{
  return mime->mm_mime_fields;
};

static inline struct mailmime_content * mailmime_get_content_type(struct mailmime * mime)
{
  return mime->mm_content_type;
};


static inline mailmessage * mailmessage_tree_get_msg(struct mailmessage_tree * msg_tree)
{
  return msg_tree->node_msg;
};

static inline uint32_t mailmessage_get_flags_std(mailmessage *msg)
{
  return msg->msg_flags->fl_flags;
}

static inline clist * mailmessage_get_flags_ext(mailmessage *msg)
{
  return msg->msg_flags->fl_extension;
};

static inline struct mailimf_mailbox_list * imf_single_fields_get_from(struct mailimf_single_fields * sfields)
{
  return sfields->fld_from->frm_mb_list;
};

static inline clist * imf_single_fields_get_from_list(struct mailimf_single_fields * sfields)
{
  return sfields->fld_from->frm_mb_list->mb_list;
};

static inline clist * imf_single_fields_get_references(struct mailimf_single_fields * sfields)
{
  return sfields->fld_references->mid_list;
};

static inline char * imf_single_fields_get_message_id(struct mailimf_single_fields * sfields)
{
  return sfields->fld_message_id->mid_value;
};

static inline char * imf_single_fields_get_subject(struct mailimf_single_fields * sfields)
{
  return sfields->fld_subject->sbj_value;
};

/* fld_return_path must be NULL-checked */
static inline char * imf_field_get_return_path(struct mailimf_field * field)
{
  return field->fld_data.fld_return_path->ret_path->pt_addr_spec;
};

/* fld_orig_date must be NULL-checked */
static inline struct mailimf_date_time * imf_field_get_orig_date(struct mailimf_field * field)
{
  return field->fld_data.fld_orig_date->dt_date_time;
};

static inline struct mailimf_date_time * imf_field_get_resent_date(struct mailimf_field * field)
{
  return field->fld_data.fld_resent_date->dt_date_time;
};

static inline struct mailimf_mailbox_list * imf_field_get_resent_from(struct mailimf_field * field)
{
  return field->fld_data.fld_resent_from->frm_mb_list;
};

static inline struct mailimf_mailbox_list * imf_field_get_from(struct mailimf_field * field)
{
  return field->fld_data.fld_from->frm_mb_list;
};

static inline clist * imf_field_get_from_list(struct mailimf_field * field)
{
  return field->fld_data.fld_from->frm_mb_list->mb_list;
};

static inline struct mailimf_mailbox * imf_field_get_resent_sender(struct mailimf_field * field)
{
  return field->fld_data.fld_resent_sender->snd_mb;
};

static inline struct mailimf_mailbox * imf_field_get_sender(struct mailimf_field * field)
{
  return field->fld_data.fld_sender->snd_mb;
};

/* list of (struct mailimf_address *) */
static inline clist * imf_field_get_resent_to(struct mailimf_field * field)
{
  return field->fld_data.fld_resent_to->to_addr_list->ad_list;
};

/* list of (struct mailimf_address *) */
static inline clist * imf_field_get_to(struct mailimf_field * field)
{
  return field->fld_data.fld_to->to_addr_list->ad_list;
};

/* list of (struct mailimf_address *) */
static inline clist * imf_field_get_resent_cc(struct mailimf_field * field)
{
  return field->fld_data.fld_resent_cc->cc_addr_list->ad_list;
};

/* list of (struct mailimf_address *) */
static inline clist * imf_field_get_cc(struct mailimf_field * field)
{
  return field->fld_data.fld_cc->cc_addr_list->ad_list;
};

/* list of (struct mailimf_address *) */
static inline clist * imf_field_get_resent_bcc(struct mailimf_field * field)
{
  return field->fld_data.fld_resent_bcc->bcc_addr_list->ad_list;
};

/* list of (struct mailimf_address *) */
static inline clist * imf_field_get_bcc(struct mailimf_field * field)
{
  return field->fld_data.fld_bcc->bcc_addr_list->ad_list;
};

static inline char * imf_field_get_message_id(struct mailimf_field * field)
{
  return field->fld_data.fld_message_id->mid_value;
};

/* list of (char *) */
static inline clist * imf_field_get_in_reply_to(struct mailimf_field * field)
{
  return field->fld_data.fld_in_reply_to->mid_list;
};

/* list of (char *) */
static inline clist * imf_field_get_references(struct mailimf_field * field)
{
  return field->fld_data.fld_references->mid_list;
};

static inline char * imf_field_get_subject(struct mailimf_field * field)
{
  return field->fld_data.fld_subject->sbj_value;
};

static inline char * imf_field_get_optional_name(struct mailimf_field * field)
{
  return field->fld_data.fld_optional_field->fld_name;
};

static inline char * imf_field_get_optional_value(struct mailimf_field * field)
{
  return field->fld_data.fld_optional_field->fld_value;
};

static inline struct mailimf_mailbox * imf_address_get_mailbox(struct mailimf_address * address)
{
  return address->ad_data.ad_mailbox;
};

static inline struct mailimf_group * imf_address_get_group(struct mailimf_address * address)
{
  return address->ad_data.ad_group;
};

static inline char  * imf_address_get_mailbox_name(struct mailimf_address * address)
{
  return address->ad_data.ad_mailbox->mb_display_name;
};

static inline char  * imf_address_get_mailbox_addr(struct mailimf_address * address)
{
  return address->ad_data.ad_mailbox->mb_addr_spec;
};

static inline char  * imf_address_get_group_name(struct mailimf_address * address)
{
  return address->ad_data.ad_group->grp_display_name;
};

/* clist of (struct mailimf_mailbox *) */
static inline clist  * imf_address_get_group_mailboxes(struct mailimf_address * address)
{
  return address->ad_data.ad_group->grp_mb_list->mb_list;
};

#endif
